| OpenCV 4.3.0 Open Source Computer Vision

Classes | Functions
Interface
Image Processing » Hardware Acceleration Layer

## Classes
struct | cvhalFilter2D
| Dummy structure storing filtering context. More...

## Functions
int | hal_ni_adaptiveThreshold (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, double maxValue, int adaptiveMethod, int thresholdType, int blockSize, double C)
| Calculates adaptive threshold. More...
int | hal_ni_boxFilter (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int src_depth, int dst_depth, int cn, int margin_left, int margin_top, int margin_right, int margin_bottom, size_t ksize_width, size_t ksize_height, int anchor_x, int anchor_y, bool normalize, int border_type)
| Calculate box filter. More...
int | hal_ni_canny (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int cn, double lowThreshold, double highThreshold, int ksize, bool L2gradient)
| Canny edge detector. More...
int | hal_ni_cvtBGR5x5toBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int dcn, bool swapBlue, int greenBits)
| hal_cvtBGR5x5toBGR More...
int | hal_ni_cvtBGR5x5toGray (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int greenBits)
| hal_cvtBGR5x5toGray More...
int | hal_ni_cvtBGRtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int scn, int dcn, bool swapBlue)
| hal_cvtBGRtoBGR More...
int | hal_ni_cvtBGRtoBGR5x5 (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int scn, bool swapBlue, int greenBits)
| hal_cvtBGRtoBGR5x5 More...
int | hal_ni_cvtBGRtoGray (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int scn, bool swapBlue)
| hal_cvtBGRtoGray More...
int | hal_ni_cvtBGRtoHSV (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int scn, bool swapBlue, bool isFullRange, bool isHSV)
| hal_cvtBGRtoHSV More...
int | hal_ni_cvtBGRtoLab (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int scn, bool swapBlue, bool isLab, bool srgb)
| hal_cvtBGRtoLab More...
int | hal_ni_cvtBGRtoThreePlaneYUV (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int scn, bool swapBlue, int uIdx)
| hal_cvtBGRtoThreePlaneYUV More...
int | hal_ni_cvtBGRtoXYZ (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int scn, bool swapBlue)
| hal_cvtBGRtoXYZ More...
int | hal_ni_cvtBGRtoYUV (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int scn, bool swapBlue, bool isCbCr)
| hal_cvtBGRtoYUV More...
int | hal_ni_cvtGraytoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int dcn)
| hal_cvtGraytoBGR More...
int | hal_ni_cvtGraytoBGR5x5 (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int greenBits)
| hal_cvtGraytoBGR5x5 More...
int | hal_ni_cvtHSVtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int dcn, bool swapBlue, bool isFullRange, bool isHSV)
| hal_cvtHSVtoBGR More...
int | hal_ni_cvtLabtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int dcn, bool swapBlue, bool isLab, bool srgb)
| hal_cvtLabtoBGR More...
int | hal_ni_cvtMultipliedRGBAtoRGBA (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height)
| hal_cvtMultipliedRGBAtoRGBA More...
int | hal_ni_cvtOnePlaneYUVtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int dcn, bool swapBlue, int uIdx, int ycn)
| hal_cvtOnePlaneYUVtoBGR More...
int | hal_ni_cvtRGBAtoMultipliedRGBA (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height)
| hal_cvtRGBAtoMultipliedRGBA More...
int | hal_ni_cvtThreePlaneYUVtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int dst_width, int dst_height, int dcn, bool swapBlue, int uIdx)
| hal_cvtThreePlaneYUVtoBGR More...
int | hal_ni_cvtTwoPlaneYUVtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int dst_width, int dst_height, int dcn, bool swapBlue, int uIdx)
| hal_cvtTwoPlaneYUVtoBGR More...
int | hal_ni_cvtXYZtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int dcn, bool swapBlue)
| hal_cvtXYZtoBGR More...
int | hal_ni_cvtYUVtoBGR (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int dcn, bool swapBlue, bool isCbCr)
| hal_cvtYUVtoBGR More...
int | hal_ni_filter (cvhalFilter2D *context, uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int full_width, int full_height, int offset_x, int offset_y)
| hal_filter More...
int | hal_ni_filterFree (cvhalFilter2D *context)
| hal_filterFree More...
int | hal_ni_filterInit (cvhalFilter2D **context, uchar *kernel_data, size_t kernel_step, int kernel_type, int kernel_width, int kernel_height, int max_width, int max_height, int src_type, int dst_type, int borderType, double delta, int anchor_x, int anchor_y, bool allowSubmatrix, bool allowInplace)
| hal_filterInit More...
int | hal_ni_gaussianBlur (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int cn, size_t margin_left, size_t margin_top, size_t margin_right, size_t margin_bottom, size_t ksize_width, size_t ksize_height, double sigmaX, double sigmaY, int border_type)
| Blurs an image using a Gaussian filter. More...
int | hal_ni_integral (int depth, int sdepth, int sqdepth, const uchar *src_data, size_t src_step, uchar *sum_data, size_t sum_step, uchar *sqsum_data, size_t sqsum_step, uchar *tilted_data, size_t tilted_step, int width, int height, int cn)
| Calculate integral image. More...
int | hal_ni_medianBlur (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int cn, int ksize)
| Calculate medianBlur filter. More...
int | hal_ni_morph (cvhalFilter2D *context, uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int src_full_width, int src_full_height, int src_roi_x, int src_roi_y, int dst_full_width, int dst_full_height, int dst_roi_x, int dst_roi_y)
| hal_morph More...
int | hal_ni_morphFree (cvhalFilter2D *context)
| hal_morphFree More...
int | hal_ni_morphInit (cvhalFilter2D **context, int operation, int src_type, int dst_type, int max_width, int max_height, int kernel_type, uchar *kernel_data, size_t kernel_step, int kernel_width, int kernel_height, int anchor_x, int anchor_y, int borderType, const double borderValue[4], int iterations, bool allowSubmatrix, bool allowInplace)
| hal_morphInit More...
int | hal_ni_pyrdown (const uchar *src_data, size_t src_step, int src_width, int src_height, uchar *dst_data, size_t dst_step, int dst_width, int dst_height, int depth, int cn, int border_type)
| Perform Gaussian Blur and downsampling for input tile. More...
int | hal_ni_resize (int src_type, const uchar *src_data, size_t src_step, int src_width, int src_height, uchar *dst_data, size_t dst_step, int dst_width, int dst_height, double inv_scale_x, double inv_scale_y, int interpolation)
| hal_resize More...
int | hal_ni_scharr (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int src_depth, int dst_depth, int cn, int margin_left, int margin_top, int margin_right, int margin_bottom, int dx, int dy, double scale, double delta, int border_type)
| Computes Scharr filter. More...
int | hal_ni_sepFilter (cvhalFilter2D *context, uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int full_width, int full_height, int offset_x, int offset_y)
| hal_sepFilter More...
int | hal_ni_sepFilterFree (cvhalFilter2D *context)
| hal_sepFilterFree More...
int | hal_ni_sepFilterInit (cvhalFilter2D **context, int src_type, int dst_type, int kernel_type, uchar *kernelx_data, int kernelx_length, uchar *kernely_data, int kernely_length, int anchor_x, int anchor_y, double delta, int borderType)
| hal_sepFilterInit More...
int | hal_ni_sobel (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int src_depth, int dst_depth, int cn, int margin_left, int margin_top, int margin_right, int margin_bottom, int dx, int dy, int ksize, double scale, double delta, int border_type)
| Computes Sobel derivatives. More...
int | hal_ni_threshold (const uchar *src_data, size_t src_step, uchar *dst_data, size_t dst_step, int width, int height, int depth, int cn, double thresh, double maxValue, int thresholdType)
| Calculates fixed-level threshold to each array element. More...
int | hal_ni_warpAffine (int src_type, const uchar *src_data, size_t src_step, int src_width, int src_height, uchar *dst_data, size_t dst_step, int dst_width, int dst_height, const double M[6], int interpolation, int borderType, const double borderValue[4])
| hal_warpAffine More...
int | hal_ni_warpPerspective (int src_type, const uchar *src_data, size_t src_step, int src_width, int src_height, uchar *dst_data, size_t dst_step, int dst_width, int dst_height, const double M[9], int interpolation, int borderType, const double borderValue[4])
| hal_warpPerspective More...

## Interpolation modes
See also cv::InterpolationFlags
#define | CV_HAL_INTER_NEAREST 0
#define | CV_HAL_INTER_LINEAR 1
#define | CV_HAL_INTER_CUBIC 2
#define | CV_HAL_INTER_AREA 3
#define | CV_HAL_INTER_LANCZOS4 4

## Morphology operations
See also cv::MorphTypes
#define | CV_HAL_MORPH_ERODE 0
#define | CV_HAL_MORPH_DILATE 1

## Threshold types
See also cv::ThresholdTypes
#define | CV_HAL_THRESH_BINARY 0
#define | CV_HAL_THRESH_BINARY_INV 1
#define | CV_HAL_THRESH_TRUNC 2
#define | CV_HAL_THRESH_TOZERO 3
#define | CV_HAL_THRESH_TOZERO_INV 4
#define | CV_HAL_THRESH_MASK 7
#define | CV_HAL_THRESH_OTSU 8
#define | CV_HAL_THRESH_TRIANGLE 16

## Adaptive threshold algorithm
See also cv::AdaptiveThresholdTypes
#define | CV_HAL_ADAPTIVE_THRESH_MEAN_C 0
#define | CV_HAL_ADAPTIVE_THRESH_GAUSSIAN_C 1

## Detailed Description

Note
  Define your functions to override default implementations:
  #undef hal_add8u
  #define hal_add8u my_add8u

## Macro Definition Documentation

## ◆ CV_HAL_ADAPTIVE_THRESH_GAUSSIAN_C

#define CV_HAL_ADAPTIVE_THRESH_GAUSSIAN_C 1

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_ADAPTIVE_THRESH_MEAN_C

#define CV_HAL_ADAPTIVE_THRESH_MEAN_C 0

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_INTER_AREA

#define CV_HAL_INTER_AREA 3

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_INTER_CUBIC

#define CV_HAL_INTER_CUBIC 2

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_INTER_LANCZOS4

#define CV_HAL_INTER_LANCZOS4 4

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_INTER_LINEAR

#define CV_HAL_INTER_LINEAR 1

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_INTER_NEAREST

#define CV_HAL_INTER_NEAREST 0

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_MORPH_DILATE

#define CV_HAL_MORPH_DILATE 1

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_MORPH_ERODE

#define CV_HAL_MORPH_ERODE 0

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_BINARY

#define CV_HAL_THRESH_BINARY 0

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_BINARY_INV

#define CV_HAL_THRESH_BINARY_INV 1

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_MASK

#define CV_HAL_THRESH_MASK 7

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_OTSU

#define CV_HAL_THRESH_OTSU 8

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_TOZERO

#define CV_HAL_THRESH_TOZERO 3

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_TOZERO_INV

#define CV_HAL_THRESH_TOZERO_INV 4

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_TRIANGLE

#define CV_HAL_THRESH_TRIANGLE 16

`#include <opencv2/imgproc/hal/interface.h>`

## ◆ CV_HAL_THRESH_TRUNC

#define CV_HAL_THRESH_TRUNC 2

`#include <opencv2/imgproc/hal/interface.h>`

## Function Documentation

## ◆ hal_ni_adaptiveThreshold()

int hal_ni_adaptiveThreshold | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | double | maxValue,
|  | int | adaptiveMethod,
|  | int | thresholdType,
|  | int | blockSize,
|  | double | C
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Calculates adaptive threshold.

Parameters

  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  maxValue | Value assigned to the pixels for which the condition is satisfied
  adaptiveMethod | Adaptive thresholding algorithm
  thresholdType | Thresholding type
  blockSize | Size of a pixel neighborhood that is used to calculate a threshold value
  C | Constant subtracted from the mean or weighted mean

## ◆ hal_ni_boxFilter()

int hal_ni_boxFilter | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | src_depth,
|  | int | dst_depth,
|  | int | cn,
|  | int | margin_left,
|  | int | margin_top,
|  | int | margin_right,
|  | int | margin_bottom,
|  | size_t | ksize_width,
|  | size_t | ksize_height,
|  | int | anchor_x,
|  | int | anchor_y,
|  | bool | normalize,
|  | int | border_type
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Calculate box filter.

Parameters

  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  src_depth,dst_depth | Depths of source and destination image
  cn | Number of channels
  margin_left,margin_top,margin_right,margin_bottom | Margins for source image
  ksize_width,ksize_height | Size of kernel
  anchor_x,anchor_y | Anchor point
  normalize | If true then result is normalized
  border_type | Border type

## ◆ hal_ni_canny()

int hal_ni_canny | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | cn,
|  | double | lowThreshold,
|  | double | highThreshold,
|  | int | ksize,
|  | bool | L2gradient
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Canny edge detector.

Parameters

  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  cn | Number of channels
  lowThreshold,highThreshold | Thresholds value
  ksize | Kernel size for Sobel operator.
  L2gradient | Flag, indicating use L2 or L1 norma.

## ◆ hal_ni_cvtBGR5x5toBGR()

int hal_ni_cvtBGR5x5toBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | dcn,
|  | bool | swapBlue,
|  | int | greenBits
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGR5x5toBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB)
  greenBits | number of bits for green channel (5 or 6) Convert from packed BGR or RGB (16 bits per pixel, 555 or 565) to BGR, BGRA, RGB and RGBA. Support only CV_8U images (input 2 channels, output 3 or 4 channels).

## ◆ hal_ni_cvtBGR5x5toGray()

int hal_ni_cvtBGR5x5toGray | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | greenBits
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGR5x5toGray

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  greenBits | number of bits for green channel (5 or 6) Convert from packed BGR (16 bits per pixel, 555 or 565) to 1-channel gray. Support only CV_8U images.

## ◆ hal_ni_cvtBGRtoBGR()

int hal_ni_cvtBGRtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | scn,
|  | int | dcn,
|  | bool | swapBlue
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U, CV_16U, CV_32F)
  scn | source image channels (3 or 4)
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R channels will be swapped (BGR->RGB or RGB->BGR) Convert between BGR, BGRA, RGB and RGBA image formats.

## ◆ hal_ni_cvtBGRtoBGR5x5()

int hal_ni_cvtBGRtoBGR5x5 | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | scn,
|  | bool | swapBlue,
|  | int | greenBits
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoBGR5x5

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  scn | source image channels (3 or 4)
  swapBlue | if set to true B and R source channels will be swapped (treat as RGB)
  greenBits | number of bits for green channel (5 or 6) Convert from BGR, BGRA, RGB and RGBA to packed BGR or RGB (16 bits per pixel, 555 or 565). Support only CV_8U images (input 3 or 4 channels, output 2 channels).

## ◆ hal_ni_cvtBGRtoGray()

int hal_ni_cvtBGRtoGray | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | scn,
|  | bool | swapBlue
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoGray

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U, CV_16U or CV_32F)
  scn | source image channels (3 or 4)
  swapBlue | if set to true B and R source channels will be swapped (treat as RGB) Convert from BGR, BGRA, RGB or RGBA to 1-channel gray.

## ◆ hal_ni_cvtBGRtoHSV()

int hal_ni_cvtBGRtoHSV | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | scn,
|  | bool | swapBlue,
|  | bool | isFullRange,
|  | bool | isHSV
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoHSV

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U or CV_32F)
  scn | source image channels (3 or 4)
  swapBlue | if set to true B and R source channels will be swapped (treat as RGB)
  isFullRange | if set to true write hue in range 0-255 (0-360 for float) otherwise in range 0-180
  isHSV | if set to true write HSV otherwise HSL Convert from BGR, RGB, BGRA or RGBA to HSV or HSL.

## ◆ hal_ni_cvtBGRtoLab()

int hal_ni_cvtBGRtoLab | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | scn,
|  | bool | swapBlue,
|  | bool | isLab,
|  | bool | srgb
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoLab

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U or CV_32F)
  scn | source image channels (3 or 4)
  swapBlue | if set to true B and R source channels will be swapped (treat as RGB)
  isLab | if set to true write Lab otherwise Luv
  srgb | if set to true use sRGB gamma correction Convert from BGR, RGB, BGRA or RGBA to Lab or Luv.

## ◆ hal_ni_cvtBGRtoThreePlaneYUV()

int hal_ni_cvtBGRtoThreePlaneYUV | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | scn,
|  | bool | swapBlue,
|  | int | uIdx
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoThreePlaneYUV

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  scn | source image channels (3 or 4)
  swapBlue | if set to true B and R source channels will be swapped (treat as RGB)
  uIdx | U-channel plane index (0 or 1) Convert from BGR, RGB, BGRA or RGBA to YUV (YUV420p (or YV12/YV21) - Y plane followed by U and V planes). Only for CV_8U.

## ◆ hal_ni_cvtBGRtoXYZ()

int hal_ni_cvtBGRtoXYZ | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | scn,
|  | bool | swapBlue
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoXYZ

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U, CV_16U or CV_32F)
  scn | source image channels (3 or 4)
  swapBlue | if set to true B and R source channels will be swapped (treat as RGB) Convert from BGR, RGB, BGRA or RGBA to XYZ.

## ◆ hal_ni_cvtBGRtoYUV()

int hal_ni_cvtBGRtoYUV | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | scn,
|  | bool | swapBlue,
|  | bool | isCbCr
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtBGRtoYUV

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U, CV_16U or CV_32F)
  scn | source image channels (3 or 4)
  swapBlue | if set to true B and R source channels will be swapped (treat as RGB)
  isCbCr | if set to true write output in YCbCr format Convert from BGR, RGB, BGRA or RGBA to YUV or YCbCr.

## ◆ hal_ni_cvtGraytoBGR()

int hal_ni_cvtGraytoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | dcn
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtGraytoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U, CV_16U or CV_32F)
  dcn | destination image channels (3 or 4) Convert from 1-channel gray to BGR, RGB, RGBA or BGRA.

## ◆ hal_ni_cvtGraytoBGR5x5()

int hal_ni_cvtGraytoBGR5x5 | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | greenBits
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtGraytoBGR5x5

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  greenBits | number of bits for green channel (5 or 6) Convert from 1-channel gray to packed BGR (16 bits per pixel, 555 or 565). Support only CV_8U images.

## ◆ hal_ni_cvtHSVtoBGR()

int hal_ni_cvtHSVtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | dcn,
|  | bool | swapBlue,
|  | bool | isFullRange,
|  | bool | isHSV
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtHSVtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U or CV_32F)
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB)
  isFullRange | if set to true read hue in range 0-255 (0-360 for float) otherwise in range 0-180
  isHSV | if set to true treat source as HSV otherwise HSL Convert from HSV or HSL to BGR, RGB, BGRA or RGBA.

## ◆ hal_ni_cvtLabtoBGR()

int hal_ni_cvtLabtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | dcn,
|  | bool | swapBlue,
|  | bool | isLab,
|  | bool | srgb
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtLabtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U or CV_32F)
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB)
  isLab | if set to true treat input as Lab otherwise Luv
  srgb | if set to true use sRGB gamma correction Convert from Lab or Luv to BGR, RGB, BGRA or RGBA.

## ◆ hal_ni_cvtMultipliedRGBAtoRGBA()

int hal_ni_cvtMultipliedRGBAtoRGBA | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtMultipliedRGBAtoRGBA

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size Convert from format with multiplied alpha channel to BGRA or RGBA. Only for CV_8U.

## ◆ hal_ni_cvtOnePlaneYUVtoBGR()

int hal_ni_cvtOnePlaneYUVtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | dcn,
|  | bool | swapBlue,
|  | int | uIdx,
|  | int | ycn
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtOnePlaneYUVtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB)
  uIdx | U-channel index (0 or 1)
  ycn | Y-channel index (0 or 1) Convert from UYVY, YUY2 or YVYU to BGR, RGB, BGRA or RGBA. Only for CV_8U.

## ◆ hal_ni_cvtRGBAtoMultipliedRGBA()

int hal_ni_cvtRGBAtoMultipliedRGBA | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtRGBAtoMultipliedRGBA

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size Convert from BGRA or RGBA to format with multiplied alpha channel. Only for CV_8U.

## ◆ hal_ni_cvtThreePlaneYUVtoBGR()

int hal_ni_cvtThreePlaneYUVtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | dst_width,
|  | int | dst_height,
|  | int | dcn,
|  | bool | swapBlue,
|  | int | uIdx
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtThreePlaneYUVtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  dst_width,dst_height | destination image size
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB)
  uIdx | U-channel plane index (0 or 1) Convert from YUV (YUV420p (or YV12/YV21) - Y plane followed by U and V planes) to BGR, RGB, BGRA or RGBA. Only for CV_8U.

## ◆ hal_ni_cvtTwoPlaneYUVtoBGR()

int hal_ni_cvtTwoPlaneYUVtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | dst_width,
|  | int | dst_height,
|  | int | dcn,
|  | bool | swapBlue,
|  | int | uIdx
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtTwoPlaneYUVtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  dst_width,dst_height | destination image size
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB)
  uIdx | U-channel index in the interleaved U/V plane (0 or 1) Convert from YUV (YUV420sp (or NV12/NV21) - Y plane followed by interleaved U/V plane) to BGR, RGB, BGRA or RGBA. Only for CV_8U.

## ◆ hal_ni_cvtXYZtoBGR()

int hal_ni_cvtXYZtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | dcn,
|  | bool | swapBlue
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtXYZtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U, CV_16U or CV_32F)
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB) Convert from XYZ to BGR, RGB, BGRA or RGBA.

## ◆ hal_ni_cvtYUVtoBGR()

int hal_ni_cvtYUVtoBGR | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | dcn,
|  | bool | swapBlue,
|  | bool | isCbCr
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_cvtYUVtoBGR

Parameters

  src_data,src_step | source image data and step
  dst_data,dst_step | destination image data and step
  width,height | image size
  depth | image depth (one of CV_8U, CV_16U or CV_32F)
  dcn | destination image channels (3 or 4)
  swapBlue | if set to true B and R destination channels will be swapped (write RGB)
  isCbCr | if set to true treat source as YCbCr Convert from YUV or YCbCr to BGR, RGB, BGRA or RGBA.

## ◆ hal_ni_filter()

int hal_ni_filter | ( | cvhalFilter2D * | context,
|  | uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | full_width,
|  | int | full_height,
|  | int | offset_x,
|  | int | offset_y
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_filter

Parameters

  context | pointer to user-defined context
  src_data | source image data
  src_step | source image step
  dst_data | destination image data
  dst_step | destination image step
  width | images width
  height | images height
  full_width | full width of source image (outside the ROI)
  full_height | full height of source image (outside the ROI)
  offset_x | source image ROI offset X
  offset_y | source image ROI offset Y

See also
  cv::filter2D, cv::hal::Filter2D

## ◆ hal_ni_filterFree()

int hal_ni_filterFree | ( | cvhalFilter2D * | context | ) |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_filterFree

Parameters

  context | pointer to user-defined context

See also
  cv::filter2D, cv::hal::Filter2D

## ◆ hal_ni_filterInit()

int hal_ni_filterInit | ( | cvhalFilter2D ** | context,
|  | uchar * | kernel_data,
|  | size_t | kernel_step,
|  | int | kernel_type,
|  | int | kernel_width,
|  | int | kernel_height,
|  | int | max_width,
|  | int | max_height,
|  | int | src_type,
|  | int | dst_type,
|  | int | borderType,
|  | double | delta,
|  | int | anchor_x,
|  | int | anchor_y,
|  | bool | allowSubmatrix,
|  | bool | allowInplace
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_filterInit

Parameters

  context | double pointer to user-defined context
  kernel_data | pointer to kernel data
  kernel_step | kernel step
  kernel_type | kernel type (CV_8U, ...)
  kernel_width | kernel width
  kernel_height | kernel height
  max_width | max possible image width, can be used to allocate working buffers
  max_height | max possible image height
  src_type | source image type
  dst_type | destination image type
  borderType | border processing mode (CV_HAL_BORDER_REFLECT, ...)
  delta | added to pixel values
  anchor_x | relative X position of center point within the kernel
  anchor_y | relative Y position of center point within the kernel
  allowSubmatrix | indicates whether the submatrices will be allowed as source image
  allowInplace | indicates whether the inplace operation will be possible

See also
  cv::filter2D, cv::hal::Filter2D

## ◆ hal_ni_gaussianBlur()

int hal_ni_gaussianBlur | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | cn,
|  | size_t | margin_left,
|  | size_t | margin_top,
|  | size_t | margin_right,
|  | size_t | margin_bottom,
|  | size_t | ksize_width,
|  | size_t | ksize_height,
|  | double | sigmaX,
|  | double | sigmaY,
|  | int | border_type
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Blurs an image using a Gaussian filter.

Parameters

  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  depth | Depth of source and destination image
  cn | Number of channels
  margin_left,margin_top,margin_right,margin_bottom | Margins for source image
  ksize_width,ksize_height | Size of kernel
  sigmaX,sigmaY | Gaussian kernel standard deviation.
  border_type | Border type

## ◆ hal_ni_integral()

int hal_ni_integral | ( | int | depth,
|  | int | sdepth,
|  | int | sqdepth,
|  | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | sum_data,
|  | size_t | sum_step,
|  | uchar * | sqsum_data,
|  | size_t | sqsum_step,
|  | uchar * | tilted_data,
|  | size_t | tilted_step,
|  | int | width,
|  | int | height,
|  | int | cn
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Calculate integral image.

Parameters

  depth,sdepth,sqdepth | Depths of source image, sum image and square sum image
  src_data,src_step | Source image
  sum_data,sum_step | Sum image
  sqsum_data,sqsum_step | Square sum image
  tilted_data,tilted_step | Tilted sum image
  width,height | Source image dimensions
  cn | Number of channels

Note
  Following combinations of image depths are used:

  Source | Sum | Square sum
  --- | --- | ---
  CV_8U | CV_32S | CV_64F
  CV_8U | CV_32S | CV_32F
  CV_8U | CV_32S | CV_32S
  CV_8U | CV_32F | CV_64F
  CV_8U | CV_32F | CV_32F
  CV_8U | CV_64F | CV_64F
  CV_16U | CV_64F | CV_64F
  CV_16S | CV_64F | CV_64F
  CV_32F | CV_32F | CV_64F
  CV_32F | CV_32F | CV_32F
  CV_32F | CV_64F | CV_64F
  CV_64F | CV_64F | CV_64F

See also
  cv::integral

## ◆ hal_ni_medianBlur()

int hal_ni_medianBlur | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | cn,
|  | int | ksize
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Calculate medianBlur filter.

Parameters

  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  depth | Depths of source and destination image
  cn | Number of channels
  ksize | Size of kernel

## ◆ hal_ni_morph()

int hal_ni_morph | ( | cvhalFilter2D * | context,
|  | uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | src_full_width,
|  | int | src_full_height,
|  | int | src_roi_x,
|  | int | src_roi_y,
|  | int | dst_full_width,
|  | int | dst_full_height,
|  | int | dst_roi_x,
|  | int | dst_roi_y
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_morph

Parameters

  context | pointer to user-defined context
  src_data | source image data
  src_step | source image step
  dst_data | destination image data
  dst_step | destination image step
  width | images width
  height | images height
  src_full_width | full width of source image (outside the ROI)
  src_full_height | full height of source image (outside the ROI)
  src_roi_x | source image ROI X offset
  src_roi_y | source image ROI Y offset
  dst_full_width | full width of destination image
  dst_full_height | full height of destination image
  dst_roi_x | destination image ROI X offset
  dst_roi_y | destination image ROI Y offset

See also
  cv::erode, cv::dilate, cv::morphologyEx, cv::hal::Morph

## ◆ hal_ni_morphFree()

int hal_ni_morphFree | ( | cvhalFilter2D * | context | ) |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_morphFree

Parameters

  context | pointer to user-defined context

See also
  cv::erode, cv::dilate, cv::morphologyEx, cv::hal::Morph

## ◆ hal_ni_morphInit()

int hal_ni_morphInit | ( | cvhalFilter2D ** | context,
|  | int | operation,
|  | int | src_type,
|  | int | dst_type,
|  | int | max_width,
|  | int | max_height,
|  | int | kernel_type,
|  | uchar * | kernel_data,
|  | size_t | kernel_step,
|  | int | kernel_width,
|  | int | kernel_height,
|  | int | anchor_x,
|  | int | anchor_y,
|  | int | borderType,
|  | const double | borderValue[4],
|  | int | iterations,
|  | bool | allowSubmatrix,
|  | bool | allowInplace
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_morphInit

Parameters

  context | double pointer to user-defined context
  operation | morphology operation CV_HAL_MORPH_ERODE or CV_HAL_MORPH_DILATE
  src_type | source image type
  dst_type | destination image type
  max_width | max possible image width, can be used to allocate working buffers
  max_height | max possible image height
  kernel_type | kernel type (CV_8U, ...)
  kernel_data | pointer to kernel data
  kernel_step | kernel step
  kernel_width | kernel width
  kernel_height | kernel height
  anchor_x | relative X position of center point within the kernel
  anchor_y | relative Y position of center point within the kernel
  borderType | border processing mode (CV_HAL_BORDER_REFLECT, ...)
  borderValue | values to use for CV_HAL_BORDER_CONSTANT mode
  iterations | number of iterations
  allowSubmatrix | indicates whether the submatrices will be allowed as source image
  allowInplace | indicates whether the inplace operation will be possible

See also
  cv::erode, cv::dilate, cv::morphologyEx, cv::hal::Morph

## ◆ hal_ni_pyrdown()

int hal_ni_pyrdown | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | int | src_width,
|  | int | src_height,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | dst_width,
|  | int | dst_height,
|  | int | depth,
|  | int | cn,
|  | int | border_type
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Perform Gaussian Blur and downsampling for input tile.

Parameters

  depth | Depths of source and destination image
  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  src_width,src_height | Source image dimensions
  dst_width,dst_height | Destination image dimensions
  cn | Number of channels
  border_type | Border type

## ◆ hal_ni_resize()

int hal_ni_resize | ( | int | src_type,
|  | const uchar * | src_data,
|  | size_t | src_step,
|  | int | src_width,
|  | int | src_height,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | dst_width,
|  | int | dst_height,
|  | double | inv_scale_x,
|  | double | inv_scale_y,
|  | int | interpolation
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_resize

Parameters

  src_type | source and destination image type
  src_data | source image data
  src_step | source image step
  src_width | source image width
  src_height | source image height
  dst_data | destination image data
  dst_step | destination image step
  dst_width | destination image width
  dst_height | destination image height
  inv_scale_x | inversed scale X coefficient
  inv_scale_y | inversed scale Y coefficient
  interpolation | interpolation mode (CV_HAL_INTER_NEAREST, ...)

See also
  cv::resize, cv::hal::resize

## ◆ hal_ni_scharr()

int hal_ni_scharr | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | src_depth,
|  | int | dst_depth,
|  | int | cn,
|  | int | margin_left,
|  | int | margin_top,
|  | int | margin_right,
|  | int | margin_bottom,
|  | int | dx,
|  | int | dy,
|  | double | scale,
|  | double | delta,
|  | int | border_type
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Computes Scharr filter.

Parameters

  src_depth,dst_depth | Depths of source and destination image
  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  cn | Number of channels
  margin_left,margin_top,margin_right,margin_bottom | Margins for source image
  dx,dy | orders of the derivative x and y respectively
  scale | Scale factor for the computed derivative values
  delta | Delta value that is added to the results prior to storing them in dst
  border_type | Border type

## ◆ hal_ni_sepFilter()

int hal_ni_sepFilter | ( | cvhalFilter2D * | context,
|  | uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | full_width,
|  | int | full_height,
|  | int | offset_x,
|  | int | offset_y
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_sepFilter

Parameters

  context | pointer to user-defined context
  src_data | source image data
  src_step | source image step
  dst_data | destination image data
  dst_step | destination image step
  width | images width
  height | images height
  full_width | full width of source image (outside the ROI)
  full_height | full height of source image (outside the ROI)
  offset_x | source image ROI offset X
  offset_y | source image ROI offset Y

See also
  cv::sepFilter2D, cv::hal::SepFilter2D

## ◆ hal_ni_sepFilterFree()

int hal_ni_sepFilterFree | ( | cvhalFilter2D * | context | ) |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_sepFilterFree

Parameters

  context | pointer to user-defined context

See also
  cv::sepFilter2D, cv::hal::SepFilter2D

## ◆ hal_ni_sepFilterInit()

int hal_ni_sepFilterInit | ( | cvhalFilter2D ** | context,
|  | int | src_type,
|  | int | dst_type,
|  | int | kernel_type,
|  | uchar * | kernelx_data,
|  | int | kernelx_length,
|  | uchar * | kernely_data,
|  | int | kernely_length,
|  | int | anchor_x,
|  | int | anchor_y,
|  | double | delta,
|  | int | borderType
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_sepFilterInit

Parameters

  context | double pointer to user-defined context
  src_type | source image type
  dst_type | destination image type
  kernel_type | kernels type
  kernelx_data | pointer to x-kernel data
  kernelx_length | x-kernel vector length
  kernely_data | pointer to y-kernel data
  kernely_length | y-kernel vector length
  anchor_x | relative X position of center point within the kernel
  anchor_y | relative Y position of center point within the kernel
  delta | added to pixel values
  borderType | border processing mode (CV_HAL_BORDER_REFLECT, ...)

See also
  cv::sepFilter2D, cv::hal::SepFilter2D

## ◆ hal_ni_sobel()

int hal_ni_sobel | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | src_depth,
|  | int | dst_depth,
|  | int | cn,
|  | int | margin_left,
|  | int | margin_top,
|  | int | margin_right,
|  | int | margin_bottom,
|  | int | dx,
|  | int | dy,
|  | int | ksize,
|  | double | scale,
|  | double | delta,
|  | int | border_type
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Computes Sobel derivatives.

Parameters

  src_depth,dst_depth | Depths of source and destination image
  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  cn | Number of channels
  margin_left,margin_top,margin_right,margin_bottom | Margins for source image
  dx,dy | orders of the derivative x and y respectively
  ksize | Size of kernel
  scale | Scale factor for the computed derivative values
  delta | Delta value that is added to the results prior to storing them in dst
  border_type | Border type

## ◆ hal_ni_threshold()

int hal_ni_threshold | ( | const uchar * | src_data,
|  | size_t | src_step,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | cn,
|  | double | thresh,
|  | double | maxValue,
|  | int | thresholdType
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

Calculates fixed-level threshold to each array element.

Parameters

  src_data,src_step | Source image
  dst_data,dst_step | Destination image
  width,height | Source image dimensions
  depth | Depths of source and destination image
  cn | Number of channels
  thresh | Threshold value
  maxValue | Value assigned to the pixels for which the condition is satisfied
  thresholdType | Thresholding type

## ◆ hal_ni_warpAffine()

int hal_ni_warpAffine | ( | int | src_type,
|  | const uchar * | src_data,
|  | size_t | src_step,
|  | int | src_width,
|  | int | src_height,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | dst_width,
|  | int | dst_height,
|  | const double | M[6],
|  | int | interpolation,
|  | int | borderType,
|  | const double | borderValue[4]
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_warpAffine

Parameters

  src_type | source and destination image type
  src_data | source image data
  src_step | source image step
  src_width | source image width
  src_height | source image height
  dst_data | destination image data
  dst_step | destination image step
  dst_width | destination image width
  dst_height | destination image height
  M | 2x3 matrix with transform coefficients
  interpolation | interpolation mode (CV_HAL_INTER_NEAREST, ...)
  borderType | border processing mode (CV_HAL_BORDER_REFLECT, ...)
  borderValue | values to use for CV_HAL_BORDER_CONSTANT mode

See also
  cv::warpAffine, cv::hal::warpAffine

## ◆ hal_ni_warpPerspective()

int hal_ni_warpPerspective | ( | int | src_type,
|  | const uchar * | src_data,
|  | size_t | src_step,
|  | int | src_width,
|  | int | src_height,
|  | uchar * | dst_data,
|  | size_t | dst_step,
|  | int | dst_width,
|  | int | dst_height,
|  | const double | M[9],
|  | int | interpolation,
|  | int | borderType,
|  | const double | borderValue[4]
| ) |  |
| inline

`#include <imgproc/src/hal_replacement.hpp>`

hal_warpPerspective

Parameters

  src_type | source and destination image type
  src_data | source image data
  src_step | source image step
  src_width | source image width
  src_height | source image height
  dst_data | destination image data
  dst_step | destination image step
  dst_width | destination image width
  dst_height | destination image height
  M | 3x3 matrix with transform coefficients
  interpolation | interpolation mode (CV_HAL_INTER_NEAREST, ...)
  borderType | border processing mode (CV_HAL_BORDER_REFLECT, ...)
  borderValue | values to use for CV_HAL_BORDER_CONSTANT mode

See also
  cv::warpPerspective, cv::hal::warpPerspective